package doclang1.editor;

/*Generated by MPS */

import jetbrains.mps.nodeEditor.EditorCellKeyMap;
import jetbrains.mps.nodeEditor.EditorCellKeyMapAction;
import java.awt.event.KeyEvent;
import jetbrains.mps.nodeEditor.EditorContext;
import jetbrains.mps.nodeEditor.cells.EditorCell;
import jetbrains.mps.smodel.SNode;
import java.util.List;
import jetbrains.mps.internal.collections.runtime.ListSequence;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SNodeOperations;
import jetbrains.mps.nodeEditor.cells.EditorCell_Property;
import org.apache.commons.lang.StringUtils;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SPropertyOperations;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SConceptOperations;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SLinkOperations;

public class TextSlice_KeyMap extends EditorCellKeyMap {

  public TextSlice_KeyMap() {
    this.setApplicableToEveryModel(false);
    EditorCellKeyMapAction action;
    action = new TextSlice_KeyMap.TextSlice_KeyMap_Action0();
    this.putAction("ctrl", "VK_SLASH", action);
    action = new TextSlice_KeyMap.TextSlice_KeyMap_Action1();
    this.putAction("ctrl", "VK_ENTER", action);
    action = new TextSlice_KeyMap.TextSlice_KeyMap_Action2();
    this.putAction("ctrl+alt", "VK_T", action);
  }
  public static class TextSlice_KeyMap_Action0 extends EditorCellKeyMapAction {

    public TextSlice_KeyMap_Action0() {
      super.setCaretPolicy(EditorCellKeyMapAction.CARET_AT_INTERMEDIATE_POSITION);
      this.setShownInPopupMenu(false);
    }

    public String getDescriptionText() {
      return "Split text";
    }

    public boolean isMenuAlwaysShown() {
      return false;
    }

    public boolean canExecute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      if ((contextCell == null)) {
        return false;
      }
      SNode contextNode = contextCell.getSNode();
      if (contextNode == null) {
        return false;
      }
      if (contextNode.isInstanceOfConcept("doclang1.structure.TextSlice")) {
        return this.canExecute_internal(keyEvent, editorContext, contextNode, this.getSelectedNodes(editorContext));
      }
      return false;
    }

    public void execute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      this.execute_internal(keyEvent, editorContext, contextCell.getSNode(), this.getSelectedNodes(editorContext));
    }

    private boolean canExecute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      //  only applicable for single node selection
      return ListSequence.fromList(selectedNodes).count() == 1 && SNodeOperations.isInstanceOf(SNodeOperations.getParent(node), "doclang1.structure.IInlineItemContainer");
    }

    private void execute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      EditorCell_Property pc = (EditorCell_Property)editorContext.getSelectedCell();
      int caretPosition = pc.getCaretPosition();
      String text1 = StringUtils.stripEnd(SPropertyOperations.getString(node, "text").substring(0, caretPosition), " \n\r\t");
      String text2 = StringUtils.stripStart(SPropertyOperations.getString(node, "text").substring(caretPosition), " \n\r\t");
      SPropertyOperations.set(node, "text", text1);
      SPropertyOperations.set(SNodeOperations.insertNewNextSiblingChild(node, "doclang1.structure.TextSlice"), "text", text2);
    }

    public String getKeyStroke() {
      return "ctrl SLASH";
    }

}
  public static class TextSlice_KeyMap_Action1 extends EditorCellKeyMapAction {

    public TextSlice_KeyMap_Action1() {
      super.setCaretPolicy(EditorCellKeyMapAction.CARET_AT_INTERMEDIATE_POSITION);
      this.setShownInPopupMenu(false);
    }

    public String getDescriptionText() {
      return "Split and insert inline-item between";
    }

    public boolean isMenuAlwaysShown() {
      return false;
    }

    public boolean canExecute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      if ((contextCell == null)) {
        return false;
      }
      SNode contextNode = contextCell.getSNode();
      if (contextNode == null) {
        return false;
      }
      if (contextNode.isInstanceOfConcept("doclang1.structure.TextSlice")) {
        return this.canExecute_internal(keyEvent, editorContext, contextNode, this.getSelectedNodes(editorContext));
      }
      return false;
    }

    public void execute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      this.execute_internal(keyEvent, editorContext, contextCell.getSNode(), this.getSelectedNodes(editorContext));
    }

    private boolean canExecute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      //  only applicable for single node selection
      return ListSequence.fromList(selectedNodes).count() == 1 && SNodeOperations.isInstanceOf(SNodeOperations.getParent(node), "doclang1.structure.IInlineItemContainer");
    }

    private void execute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      EditorCell_Property pc = (EditorCell_Property)editorContext.getSelectedCell();
      int caretPosition = pc.getCaretPosition();
      String text1 = StringUtils.stripEnd(SPropertyOperations.getString(node, "text").substring(0, caretPosition), " \n\r\t");
      String text2 = StringUtils.stripStart(SPropertyOperations.getString(node, "text").substring(caretPosition), " \n\r\t");
      SPropertyOperations.set(node, "text", text1);
      SPropertyOperations.set(SNodeOperations.insertNewNextSiblingChild(SNodeOperations.insertNextSiblingChild(node, SConceptOperations.createNewNode("doclang1.structure.IInlineItem", null)), "doclang1.structure.TextSlice"), "text", text2);
    }

    public String getKeyStroke() {
      return "ctrl ENTER";
    }

}
  public static class TextSlice_KeyMap_Action2 extends EditorCellKeyMapAction {

    public TextSlice_KeyMap_Action2() {
      this.setShownInPopupMenu(false);
    }

    public String getDescriptionText() {
      return "Add marker to selected text";
    }

    public boolean isMenuAlwaysShown() {
      return false;
    }

    public boolean canExecute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      if ((contextCell == null)) {
        return false;
      }
      SNode contextNode = contextCell.getSNode();
      if (contextNode == null) {
        return false;
      }
      if (contextNode.isInstanceOfConcept("doclang1.structure.TextSlice")) {
        return this.canExecute_internal(keyEvent, editorContext, contextNode, this.getSelectedNodes(editorContext));
      }
      return false;
    }

    public void execute(final KeyEvent keyEvent, final EditorContext editorContext) {
      EditorCell contextCell = editorContext.getContextCell();
      this.execute_internal(keyEvent, editorContext, contextCell.getSNode(), this.getSelectedNodes(editorContext));
    }

    private boolean canExecute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      //  only applicable for single node selection
      if (!(ListSequence.fromList(selectedNodes).count() == 1 && SNodeOperations.isInstanceOf(SNodeOperations.getParent(node), "doclang1.structure.IInlineItemContainer"))) {
        return false;
      }
      //  applicable if text is selected inside a text slice
      EditorCell cell = editorContext.getSelectedCell();
      return (cell instanceof EditorCell_Property) && ((EditorCell_Property)cell).getSelectedText().length() > 0;
    }

    private void execute_internal(final KeyEvent keyEvent, final EditorContext editorContext, final SNode node, final List<SNode> selectedNodes) {
      EditorCell_Property propertyCell = ((EditorCell_Property)editorContext.getSelectedCell());
      int caretPosition = propertyCell.getCaretPosition();
      String selectedText = propertyCell.getSelectedText();
      //  tmp: define start/end position of selection (tricky, will be better in next MPS build)
      int selectionStart = caretPosition;
      if (!(SPropertyOperations.getString(node, "text").substring(caretPosition).startsWith(selectedText))) {
        selectionStart = caretPosition - selectedText.length();
      }
      int selectionEnd = selectionStart + selectedText.length();
      //  split text slice
      String text1 = SPropertyOperations.getString(node, "text").substring(0, selectionStart);
      String text2 = SPropertyOperations.getString(node, "text").substring(selectionEnd);
      SNode newMarker = SNodeOperations.insertNewNextSiblingChild(node, "doclang1.structure.AbstractInlineMarker");
      SPropertyOperations.set(SLinkOperations.addNewChild(newMarker, "item", "doclang1.structure.TextSlice"), "text", selectedText);
      if (text2.length() > 0) {
        SPropertyOperations.set(SNodeOperations.insertNewNextSiblingChild(newMarker, "doclang1.structure.TextSlice"), "text", text2);
      }
      if (text1.length() > 0) {
        SPropertyOperations.set(node, "text", text1);
      } else
      {
        SNodeOperations.deleteNode(node);
      }
    }

    public String getKeyStroke() {
      return "ctrl alt T";
    }

}

}
