package doclang1.intentions;

/*Generated by MPS */

import jetbrains.mps.intentions.BaseIntention;
import jetbrains.mps.smodel.SNode;
import jetbrains.mps.nodeEditor.EditorContext;
import jetbrains.mps.nodeEditor.cells.EditorCell;
import jetbrains.mps.nodeEditor.cells.EditorCell_Property;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SPropertyOperations;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SNodeOperations;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SLinkOperations;

public class AddMarkerToText_Intention extends BaseIntention {

  public String getConcept() {
    return "doclang1.structure.TextSlice";
  }

  public boolean isErrorIntention() {
    return false;
  }

  public boolean isAvailableInChildNodes() {
    return false;
  }

  public String getDescription(final SNode node, final EditorContext editorContext) {
    return "Add marker to selected text";
  }

  public boolean isApplicable(final SNode node, final EditorContext editorContext) {
    //  only applicable to single selection
    if (editorContext.getSelectedNodes().size() > 1) {
      return false;
    }
    EditorCell cell = editorContext.getSelectedCell();
    return (cell instanceof EditorCell_Property) && ((EditorCell_Property)cell).getSelectedText().length() > 0;
  }

  public void execute(final SNode node, final EditorContext editorContext) {
    EditorCell_Property propertyCell = ((EditorCell_Property)editorContext.getSelectedCell());
    int caretPosition = propertyCell.getCaretPosition();
    String selectedText = propertyCell.getSelectedText();
    //  tmp: define start/end position of selection (will be better wat in next build)
    int selectionStart = caretPosition;
    if (!(SPropertyOperations.getString(node, "text").substring(caretPosition).startsWith(selectedText))) {
      selectionStart = caretPosition - selectedText.length();
    }
    int selectionEnd = selectionStart + selectedText.length();
    //  split text slice
    String text1 = SPropertyOperations.getString(node, "text").substring(0, selectionStart);
    String text2 = SPropertyOperations.getString(node, "text").substring(selectionEnd);
    SNode newMarker = SNodeOperations.insertNewNextSiblingChild(node, "doclang1.structure.AbstractInlineMarker");
    SPropertyOperations.set(SLinkOperations.addNewChild(newMarker, "item", "doclang1.structure.TextSlice"), "text", selectedText);
    if (text2.length() > 0) {
      SPropertyOperations.set(SNodeOperations.insertNewNextSiblingChild(newMarker, "doclang1.structure.TextSlice"), "text", text2);
    }
    if (text1.length() > 0) {
      SPropertyOperations.set(node, "text", text1);
    } else
    {
      SNodeOperations.deleteNode(node);
    }
  }

  public String getLocationString() {
    return "doclang1.intentions";
  }

}
