package doclang1.intentions;

/*Generated by MPS */

import jetbrains.mps.intentions.BaseIntention;
import jetbrains.mps.smodel.SNode;
import jetbrains.mps.nodeEditor.EditorContext;
import java.util.List;
import jetbrains.mps.internal.collections.runtime.ListSequence;
import jetbrains.mps.internal.collections.runtime.IWhereFilter;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SNodeOperations;
import jetbrains.mps.lang.smodel.generator.smodelAdapter.SPropertyOperations;

public class ConcatenateTextSlices_Intention extends BaseIntention {

  public String getConcept() {
    return "doclang1.structure.TextSlice";
  }

  public boolean isErrorIntention() {
    return false;
  }

  public boolean isAvailableInChildNodes() {
    return false;
  }

  public String getDescription(final SNode node, final EditorContext editorContext) {
    return "Concatenate text slices";
  }

  public boolean isApplicable(final SNode node, final EditorContext editorContext) {
    //  multiple items are selected and selection only consists of 'text slices' 
    List<SNode> nodes = editorContext.getSelectedNodes();
    return ListSequence.fromList(nodes).count() > 1 && ListSequence.fromList(nodes).findFirst(new IWhereFilter <SNode>() {

      public boolean accept(SNode it) {
        return !(SNodeOperations.isInstanceOf(it, "doclang1.structure.TextSlice"));
      }

    }) == null;
  }

  public void execute(final SNode node, final EditorContext editorContext) {
    List<SNode> slices = (List<SNode>)editorContext.getSelectedNodes();
    SNode firstSlice = ListSequence.fromList(slices).first();
    for(SNode slice : ListSequence.fromList(slices)) {
      if (slice != firstSlice) {
        SPropertyOperations.set(firstSlice, "text", SPropertyOperations.getString_def(firstSlice, "text", "") + (" " + SPropertyOperations.getString(slice, "text")));
        SNodeOperations.deleteNode(slice);
      }
    }
  }

  public String getLocationString() {
    return "doclang1.intentions";
  }

}
